﻿# -*- coding: utf-8 -*-


import copy
import math

#選択面にポリゴンメッシュを移植

#選択している面に下（弟階層）のポリゴンメッシュを移植します

#実行前に下のポリゴンメッシュの頂点（移植先とエッジをはる頂点）を記憶しておく必要があります

#選択面のうち非平面の面や頂点数が5点以上の面には貼り付けできません


#移植するポリゴンメッシュ（下のポリゴンメッシュ）は原点を中心に作成してください。
#面の向きにあわせる場合は、原点の中心、z軸上向きに作成してください。


#変数とパラメータ
#broid・・・・弟階層のuuidをチェック
#harilist22・・・はりつけ処理を行う頂点リスト（事前に記憶する）
#brocpnum・・・弟階層のコントロールポイント数

#direction・・・0で向きはそのまま　1で向きを面の法線方向にあわせる
#resize・・・0で大きさそのまま　1でサイズを変える（基準は中心位置から一番遠い頂点までの距離）
#scale・・・倍率


#動作条件
#記憶の場合
#選択形状がポリゴンメッシュ
#編集モード
#頂点編集モード
#頂点が3個以上選択されている

#貼り付け処理の場合
#選択形状がポリゴンメッシュ
#編集モード
#面編集モード
#面が一つ以上選択されている
#弟階層にポリゴンメッシュ
#弟のポリゴンメッシュのuuidと変数のuuidが一致



def return_kaiten(pos,cpos,kakudo2,ziku):
  #posをcposを中心にziku（0x軸、1y軸、2z軸）まわりにkakudoだけ回転させて返す

  kakudo=(2*math.pi*kakudo2)/360
  tempos5=[pos[0]-cpos[0],pos[1]-cpos[1],pos[2]-cpos[2]]
  newpos=[tempos5[0],tempos5[1],tempos5[2]]

  if ziku==0:
    newpos[1]=tempos5[1]*math.cos(kakudo)-tempos5[2]*math.sin(kakudo)
    newpos[2]=tempos5[1]*math.sin(kakudo)+tempos5[2]*math.cos(kakudo)

  if ziku==1:
    newpos[2]=tempos5[2]*math.cos(kakudo)-tempos5[0]*math.sin(kakudo)
    newpos[0]=tempos5[2]*math.sin(kakudo)+tempos5[0]*math.cos(kakudo)

  if ziku==2:
    newpos[0]=tempos5[0]*math.cos(kakudo)-tempos5[1]*math.sin(kakudo)
    newpos[1]=tempos5[0]*math.sin(kakudo)+tempos5[1]*math.cos(kakudo)

  newpos=[newpos[0]+cpos[0],newpos[1]+cpos[1],newpos[2]+cpos[2]]
  return newpos


def return_vec(avec):
  #単位ベクトルに変換して返す
  if (avec[0]**2+avec[1]**2+avec[2]**2)!=0:
    bun=pow(avec[0]**2+avec[1]**2+avec[2]**2,0.5)
    newvec=[avec[0]/bun,avec[1]/bun,avec[2]/bun]
  else:
    newvec=[0,0,0]

  return newvec



def return_henkan_pos(pos,mat):
  #posをmatで変換した座標（タプル）を返す
  tempx=pos[0]
  tempy=pos[1]
  tempz=pos[2]
  x1=mat[0][0]*tempx+mat[1][0]*tempy+mat[2][0]*tempz+mat[3][0]*1
  y1=mat[0][1]*tempx+mat[1][1]*tempy+mat[2][1]*tempz+mat[3][1]*1
  z1=mat[0][2]*tempx+mat[1][2]*tempy+mat[2][2]*tempz+mat[3][2]*1
  return [x1,y1,z1]


def henkan(pos,mode22):

  #mode22が0の場合ローカル座標からワールド座標へ変換
  #mode22が1の場合ワールド座標から図形ウインドウ座標へ変換
  #mode22が2の場合図形ウインドウ座標からワールド座標へ変換
  #mode22が3の場合ワールド座標からローカル座標へ変換

  if mode22==0:mat2=xshade.scene().active_shape().local_to_world_matrix
  if mode22==1:mat2=xshade.scene().world_to_user_matrix
  if mode22==2:mat2=xshade.scene().user_to_world_matrix
  if mode22==3:mat2=xshade.scene().active_shape().world_to_local_matrix


  tempx=pos[0]
  tempy=pos[1]
  tempz=pos[2]


  x1=mat2[0][0]*tempx+mat2[1][0]*tempy+mat2[2][0]*tempz+mat2[3][0]*1
  y1=mat2[0][1]*tempx+mat2[1][1]*tempy+mat2[2][1]*tempz+mat2[3][1]*1
  z1=mat2[0][2]*tempx+mat2[1][2]*tempy+mat2[2][2]*tempz+mat2[3][2]*1

  return [x1,y1,z1]








dousasuru=0

xscene=xshade.scene()
ashape=xshade.scene().active_shape()

#記憶処理

if ashape.type==7 and xscene.is_modify_mode==True:
  if xscene.selection_mode==1:xscene.selection_mode=2

  if xscene.selection_mode==2:
    aplist=[]
    for i in range(ashape.total_number_of_control_points):
      if ashape.vertex(i).active==True:
        aplist.append(i)

    if len(aplist)>2:
      broid=ashape.uuid
      harilist22=copy.copy(aplist)
      brocpnum=ashape.total_number_of_control_points

      dialog=xshade.create_dialog()
      dialog.append_push_button('貼り付けポイントを')
      dialog.append_push_button('記憶しました')
      dialog.ask('記憶完了')


#移植処理

if ashape.type==7 and xscene.is_modify_mode==True:
  if ashape.has_bro==True:

    okk=0
    try:
      if ashape.bro.uuid==broid:okk=1
#      else:okk=2

    except NameError:
      dialog=xshade.create_dialog()
      dialog.append_push_button('下のポリゴンメッシュを')
      dialog.append_push_button('選択して')
      dialog.append_push_button('貼り付けポイントを')
      dialog.append_push_button('記憶してください')
      dialog.ask('エラー')

#    if okk==2:
#      dialog=xshade.create_dialog()
#      dialog.append_push_button('下のポリゴンメッシュを')
#      dialog.append_push_button('選択して')
#      dialog.append_push_button('貼り付けポイントを')
#      dialog.append_push_button('記憶しなおしてください')
#      dialog.ask('エラー')

    if okk==1 and ashape.bro.total_number_of_control_points==brocpnum:
      if xscene.selection_mode==0:
        aflist=[]
        for i in range(ashape.number_of_faces):
          if ashape.face(i).active==True:
            aflist.append(i)
        if len(aflist)>0:dousasuru=1



if dousasuru>0:
  #上位パートに変換がかかっているなら動作しない

  if xshade.scene().active_shape().local_to_world_matrix!=((1.0, 0.0, 0.0, 0.0), (0.0, 1.0, 0.0, 0.0), (0.0, 0.0, 1.0, 0.0), (0.0, 0.0, 0.0, 1.0)):
    dousasuru=0
    dialog=xshade.create_dialog()
    dialog.append_push_button('上位パートに変換がかかっているため')
    dialog.append_push_button('スクリプトが実行できません')
    
    dialog.ask('エラー')

if dousasuru==1:
  afclist=copy.copy(aflist)
  #非平面の面と四頂点以上の面は移植先から除外
  kesul=[]
  for i in afclist:
    tvlist=ashape.face(i).vertex_indices
    if len(tvlist)>4:
      kesul.append(i)
#      husu=0

    else:

      if len(tvlist)>3:
        pos1=ashape.vertex(tvlist[0]).position
        pos2=ashape.vertex(tvlist[1]).position
        pos3=ashape.vertex(tvlist[2]).position

        pos11=ashape.vertex(tvlist[len(tvlist)-1]).position
        pos12=ashape.vertex(tvlist[len(tvlist)-1-1]).position
        pos13=ashape.vertex(tvlist[len(tvlist)-1-2]).position

        if xshade.make_plane_equation((pos1,pos2,pos3))!=xshade.make_plane_equation((pos11,pos12,pos13)):
          kesul.append(i)
  for i in kesul:
    afclist.remove(i)

  #デバッグ用
  afclist=copy.copy(aflist)



if dousasuru==1:

  harilist=copy.copy(harilist22)

  #ここに初期値
  renzoku=1
  direction=0#0で向きはそのまま 1で面の向きにあわせる
  resize=0#0で大きさそのまま　1でサイズを面の大きさにあわせる
  scale=1#大きさをあわせる際の倍率（中心から一番遠い頂点への距離が基準）

  #弟階層のポリゴンメッシュの情報
  pposlist=[]#頂点の位置情報を頂点番号順に記憶
  eplist=[]#エッジのｖ0ｖ1リストを辺番号順に記憶
  fvlist=[]#面を構成する頂点リストを面番号順に記憶

  brobro=ashape.bro
  for i in range(brobro.total_number_of_control_points):
    pposlist.append(brobro.vertex(i).position)
  for i in range(brobro.number_of_edges):
    tv0=brobro.edge(i).v0
    tv1=brobro.edge(i).v1
    eplist.append([tv0,tv1])

  for i in range(brobro.number_of_faces):
    fvlist.append(brobro.face(i).vertex_indices)



  while(renzoku==1):
    #ダイアログ表示
    dialog=xshade.create_dialog()


    dialog.begin_group('サイズ')
    idx9=dialog.append_radio_button('/一定/面の大きさにあわせる')
    dialog.end_group()

    dialog.begin_group('方向')
    idx8=dialog.append_radio_button('/向きそのまま/面の向きにあわせる')
    dialog.end_group()

    idx7=dialog.append_float('倍率')

    dialog.set_value(idx8,direction)
    dialog.set_value(idx9,resize)
    dialog.set_value(idx7,scale)

    kekka=dialog.ask('選択面にポリゴンメッシュを移植')

    if kekka==False:renzoku=0

    else:
      direction=dialog.get_value(idx8)
      resize=dialog.get_value(idx9)
      scale=dialog.get_value(idx7)

      #元の形状をクリップボードにコピー
      ashape.copy()
      xscene.enter_modify_mode()

      #元の頂点位置情報を保存
      pposcopy=copy.copy(pposlist)

      #元のポリゴンメッシュの基準の長さ
      length=pow(pposcopy[0][0]**2+pposcopy[0][1]**2+pposcopy[0][2]**2,0.5)
      lengthmin=length
      for i in pposcopy:
        tlen=pow(i[0]**2+i[1]**2+i[2]**2,0.5)
        if tlen>length:length=tlen
        if tlen<lengthmin:lengthmin=tlen

      length=(length+lengthmin)/2

      #倍率にあわせて頂点位置情報を修正
      scalepos=[]#倍率をかけあわせた位置情報
      for i in pposcopy:
        scalepos.append([i[0]*scale,i[1]*scale,i[2]*scale])


      #選択面ごとに移植する
      for i in afclist:
        maxnum=ashape.total_number_of_control_points

        center=[0,0,0]#選択面の中心座標（平均座標）
        afvlist=list(ashape.face(i).vertex_indices)#選択面の構成頂点
        setuzokusumi=[]#接続済みか
        for tt in range(len(afvlist)):
          setuzokusumi.append(0)

        for gg in afvlist:
          tempos=ashape.vertex(gg).position
          center=[center[0]+tempos[0],center[1]+tempos[1],center[2]+tempos[2]]

        center=[center[0]/len(afvlist),center[1]/len(afvlist),center[2]/len(afvlist)]

        length2=pow((tempos[0]-center[0])**2+(tempos[1]-center[1])**2+(tempos[2]-center[2])**2,0.5)
        length2min=length2
        for gg in afvlist:
          tempos=ashape.vertex(gg).position
          tlen2=pow((tempos[0]-center[0])**2+(tempos[1]-center[1])**2+(tempos[2]-center[2])**2,0.5)
          if tlen2>length2:length2=tlen2
          if tlen2<length2min:length2min=tlen2
        length2=(length2+length2min)/2


        #サイズを面ごとにあわせるか？
        imapos=copy.copy(scalepos)
        if resize==1:
          sc2=length2/length
          for hh in range(len(imapos)):
            imapos[hh]=[imapos[hh][0]*sc2,imapos[hh][1]*sc2,imapos[hh][2]*sc2]

        #面の向きにあわせて回転
        if direction==1:
          #面の法線を求める
          fnormal=xshade.make_plane_equation((ashape.vertex(afvlist[0]).position,ashape.vertex(afvlist[1]).position,ashape.vertex(afvlist[2]).position))
          tempnormal=ashape.vertex(afvlist[0]).normal
          if (fnormal[0]*tempnormal[0]+fnormal[1]*tempnormal[1]+fnormal[2]*tempnormal[2])<(-fnormal[0]*tempnormal[0]-fnormal[1]*tempnormal[1]-fnormal[2]*tempnormal[2]):
            fnormal=[fnormal[0]*-1,fnormal[1]*-1,fnormal[2]*-1]
          fnormal=return_vec([fnormal[0],fnormal[1],fnormal[2]])

          #回転のための変換マトリクス
          mat44=xshade.get_amat((0.0,1.0,0.0),(fnormal[0],fnormal[1],fnormal[2]))


          #変換マトリクスからY軸まわりの回転要素を抜き出して頂点を逆回転
#          unmat=xshade.unmatrix(mat44)
#          unmaty=unmat[3][2]

#          for pp in range(len(imapos)):
#            imapos[pp]=return_kaiten(imapos[pp],[0,0,0],-unmaty,1)


          #移植するポリゴンメッシュの頂点を回転
          for pp in range(len(imapos)):
            imapos[pp]=return_henkan_pos(imapos[pp],mat44)
            

        #面の中心位置へ移動
        for pp in range(len(imapos)):
          imapos[pp]=[imapos[pp][0]+center[0],imapos[pp][1]+center[1],imapos[pp][2]+center[2]]

        #移植するポリゴンメッシュの頂点、辺、面を追加
        for tt in imapos:
          ashape.append_point(tt)

        for tt in eplist:
          ashape.make_edge(maxnum+tt[0],maxnum+tt[1])

        for tt in fvlist:
          ii=list(tt)
          for gg in range(len(ii)):
            ii[gg]=ii[gg]+maxnum

          ashape.append_face(ii)

        edgelist=[]

        #貼り付けポイントと面を構成する頂点間にエッジを張る

        for tt in harilist:
          templist=[]
          #各貼り付けポイントから一番近くの面の頂点へエッジを張る
          ttpos=ashape.vertex(afvlist[0]).position
          ttdist=pow((ttpos[0]-imapos[tt][0])**2+(ttpos[1]-imapos[tt][1])**2+(ttpos[2]-imapos[tt][2])**2,0.5)
          minnum=0
          templist.append([minnum,ttdist])
          for gg in range(len(afvlist)):
            ttpos=ashape.vertex(afvlist[gg]).position
            ttdist2=pow((ttpos[0]-imapos[tt][0])**2+(ttpos[1]-imapos[tt][1])**2+(ttpos[2]-imapos[tt][2])**2,0.5)
            if ttdist>=ttdist2:
              templist.insert(0,[gg,ttdist2])
              ttdist=ttdist2
            else:
              templist.append([gg,ttdist2])
#              minnum=gg

          dist5=templist[0][1]
          for ff in templist:
            if ff[1]==dist5:
              ashape.append_edge(afvlist[ff[0]],tt+maxnum)
              setuzokusumi[ff[0]]=1


#          ashape.append_edge(afvlist[minnum],tt+maxnum)
#          edgelist.append([afvlist[minnum],tt+maxnum-1])
#          setuzokusumi[minnum]=1

        edgelist2=[]

        #まだ接続されてない面上の頂点から貼り付けポイントへエッジを張る
        for tt in range(len(setuzokusumi)):
          if setuzokusumi[tt]==0:
            ttpos=ashape.vertex(afvlist[tt]).position
            ttdist=pow((ttpos[0]-imapos[harilist[0]][0])**2+(ttpos[1]-imapos[harilist[0]][1])**2+(ttpos[2]-imapos[harilist[0]][2])**2,0.5)
            minnum=harilist[0]
            for gg in harilist:
              ttdist2=pow((ttpos[0]-imapos[gg][0])**2+(ttpos[1]-imapos[gg][1])**2+(ttpos[2]-imapos[gg][2])**2,0.5)
              if ttdist2<ttdist:
                ttdist=ttdist2
                minnum=gg
#                print [tt,minnum]

            ashape.append_edge(afvlist[tt],minnum+maxnum)

#        edgelist=edgelist+edgelist2
#        for tt in edgelist:
#          ashape.append_edge(tt[0],tt[1])


      #選択面を全て削除
      ashape.begin_removing_faces()
      for i in afclist:
        ashape.face(i).remove()
      ashape.end_removing_faces()

#      print afclist

      #面の向きをそろえる
      ashape.adjust_face_direction()

      #重複点マージ
      ashape.cleanup_redundant_vertices()


      #元に戻すか聞く
      dialog=xshade.create_dialog()
      idx3=dialog.append_push_button('処理を確定しますか?')
      xshade.scene().enter_modify_mode()
      kekka=dialog.ask('選択面にポリゴンメッシュを移植')

      if kekka==True:renzoku=0

      if kekka==False:
        idou1=0
        if xshade.scene().active_shape().has_sis==True:
          idou1=1
        xshade.scene().paste()
        xshade.scene().select_sister(1)
        xshade.scene().clear()
        if idou1==1:
          xshade.scene().select_brother()
        xshade.scene().enter_modify_mode()
        ashape=xshade.scene().active_shape() 
        for i in aflist:
          ashape.face(i).active=True




