﻿# -*- coding: utf-8 -*-


import copy
import math

#スムージング




#動作条件
#選択形状がポリゴンメッシュ
#編集モードに入っている
#頂点選択モード
#頂点が一つ以上選択されている
#上位パートに変換がかかっていない事



#設定項目

def return_svec(vec):
  #単位ベクトルにして返す
  dist=vec[0]**2+vec[1]**2+vec[2]**2
  dist=pow(dist,0.5)
  if dist==0:return vec
  else:
    return [vec[0]/dist,vec[1]/dist,vec[2]/dist]




def sort_point_by_active_order(pointlist):
  #頂点の選択番号(active_order)順にリストの頂点番号をソートして頂点リストを返す
  
  #ソート
  templist=[]
  for i in pointlist:
    templist.append(i)
  newlist=[]
  while(len(newlist)<len(pointlist)):
    minnumber=0 #リストのminnumber目の頂点の選択番号が最小値
    for i in range(1,len(templist)):
      if xshade.scene().active_shape().vertex(templist[i]).active_order<xshade.scene().active_shape().vertex(templist[minnumber]).active_order:
        minnumber=i
    newlist.append(templist[minnumber])
    templist.remove(templist[minnumber]) 

  return newlist       



dousasuru=0
error=0

xscene=xshade.scene()
ashape=xshade.scene().active_shape()
ashapes=xshade.scene().active_shapes
cpnum=ashape.total_number_of_control_points

if ashape.type==7 and xscene.is_modify_mode==True and len(ashapes)==1:
  if xscene.selection_mode==2:
    aplist=[]#選択頂点リスト
    for i in range(ashape.total_number_of_control_points):
      if ashape.vertex(i).active==True:
        aplist.append(i)

    if len(aplist)>0:
      dousasuru=1
      aplist=sort_point_by_active_order(aplist)


if dousasuru==0:
  dousasuru=0
  dialog=xshade.create_dialog()
  dialog.append_push_button('ポリゴンメッシュを一つ選択して')
  dialog.append_push_button('頂点編集モードに入って')
  dialog.append_push_button('頂点を一つ以上選択してください')
  
  dialog.ask('エラー')



if dousasuru>0:
  #上位パートに変換がかかっているなら動作しない

  if xshade.scene().active_shape().local_to_world_matrix!=((1.0, 0.0, 0.0, 0.0), (0.0, 1.0, 0.0, 0.0), (0.0, 0.0, 1.0, 0.0), (0.0, 0.0, 0.0, 1.0)):
    dousasuru=0
    dialog=xshade.create_dialog()
    dialog.append_push_button('上位パートに変換がかかっているため')
    dialog.append_push_button('スクリプトが実行できません')
    
    dialog.ask('エラー')



if dousasuru==1:

  #ここに初期値
  renzoku=1
  mode=0#0がスムージング、１が最初に戻す、2が終了
  xkotei=0#x座標固定のONとOFF（1がON）
  ykotei=0
  zkotei=0
  vvalue=0.25#移動量にこの値をかける
  svecon=1#接続辺の長さを考慮する

  #元の形状情報をコピーして上に置いておく
  ashape.copy()
  xscene.paste()
  xscene.select_sister(1)
  xscene.hide_active()
  xscene.select_brother(1)
  ashape=xshade.scene().active_shape()
  xscene.enter_modify_mode()

  while(renzoku==1):
    #ダイアログ表示
    dialog=xshade.create_dialog()

    idx1=dialog.append_radio_button('アクション/スムージング/最初に戻す/終了（確定）')

    dialog.begin_group()
    idx2=dialog.append_bool('X座標固定')
    idx3=dialog.append_bool('Y座標固定')
    idx4=dialog.append_bool('Z座標固定')
    idx5=dialog.append_float('値')
    idx6=dialog.append_bool('接続辺の長さを考慮する')


    dialog.end_group

    dialog.set_value(idx1,mode)
    dialog.set_value(idx2,xkotei)
    dialog.set_value(idx3,ykotei)
    dialog.set_value(idx4,zkotei)
    dialog.set_value(idx5,vvalue)
    dialog.set_value(idx6,svecon)



    kekkaa=dialog.ask('スムージング')

    if kekkaa==True:
      mode=dialog.get_value(idx1)
      xkotei=dialog.get_value(idx2)
      ykotei=dialog.get_value(idx3)
      zkotei=dialog.get_value(idx4)
      vvalue=dialog.get_value(idx5)
      svecon=dialog.get_value(idx6)


      if mode==0:

        #選択頂点の位置リスト
        apposlist=[]
        for i in aplist:
          apposlist.append(ashape.vertex(i).position)

        #元の頂点位置リスト
        motolist=[]
        for i in range(ashape.total_number_of_control_points):
          motolist.append(ashape.vertex(i).position)

        #接続点リスト(頂点番号順）
        slist=[]
        for i in range(ashape.total_number_of_control_points):
          slist.append([])

        for i in range(ashape.number_of_edges):
          v0=ashape.edge(i).v0
          v1=ashape.edge(i).v1

          slist[v0].append(v1)
          slist[v1].append(v0)

        #各頂点ごとに処理
        for i in range(len(aplist)):
          motop=apposlist[i]

          #接続点へのベクトルの合算と平均化
          sum=len(slist[aplist[i]])
          if sum>0:
            vec=[0,0,0]
            sumlength=0
            for gg in slist[aplist[i]]:
              tvec=[motolist[gg][0]-motop[0],motolist[gg][1]-motop[1],motolist[gg][2]-motop[2]]
              if svecon==0:
                tlength=pow(tvec[0]**2+tvec[1]**2+tvec[2]**2,0.5)
                sumlength+=tlength
                tvec=return_svec(tvec)

              vec=[vec[0]+tvec[0],vec[1]+tvec[1],vec[2]+tvec[2]]

            if svecon==0:
              length=sumlength/sum
              vec=[vec[0]*length,vec[1]*length,vec[2]*length]

            vec=[vec[0]*vvalue/sum,vec[1]*vvalue/sum,vec[2]*vvalue/sum]

            #移動


            newpos=[motop[0]+vec[0]*(1-xkotei),motop[1]+vec[1]*(1-ykotei),motop[2]+vec[2]*(1-zkotei)]
            ashape.vertex(aplist[i]).position=newpos



      if mode==1:
#        idou1=0
#        if xshade.scene().active_shape().has_sis==True:
#          idou1=1
#        xshade.scene().paste()
#        xshade.scene().select_sister(1)
#        xshade.scene().clear()
#        if idou1==1:
#          xshade.scene().select_brother()
#        xshade.scene().enter_modify_mode()
#        ashape=xshade.scene().active_shape() 
#        for i in aplist:
#          ashape.vertex(i).active=True
        xscene.clear()
        xscene.active_shape().copy()
        xscene.paste()
        ashape=xscene.active_shape()
        xscene.show_active()
        xscene.enter_modify_mode()


      if mode==2:
        renzoku=0
        #上の形状を消す
        xscene.select_sister(1)
        idou=0
        if xscene.active_shape().has_sis==True:
          idou=1
        xscene.clear()
        if idou==1:
          xscene.select_brother(1)
        xscene.enter_modify_mode()
        ashape=xshade.scene().active_shape()
        for i in aplist:
          ashape.vertex(i).active=True








