﻿# -*- coding: utf-8 -*-


import copy
import math

#一括ベルト抜き
#2010.11.22

#選択辺それぞれをループ状に拡張した後ベルト抜きを行います


#動作条件
#選択形状が一つでポリゴンメッシュ
#編集モードに入っている
#辺編集モードに入っている
#辺を一つ以上選択している
#上位パートに変換がかかっていない



#↓動作確認ずみ
def return_edge_number(pointnum1,pointnum2):
  #頂点二つの頂点番号を与えると、その頂点で構成される辺の辺番号を返す
  #エラー（辺の両端のポイントでは無い）の場合は-1を返す
  returnnum=-1
  for i in range(xshade.scene().active_shape().number_of_edges):
    if xshade.scene().active_shape().edge(i).v0==pointnum1 and xshade.scene().active_shape().edge(i).v1==pointnum2:
      returnnum=i
      break

    if xshade.scene().active_shape().edge(i).v1==pointnum1 and xshade.scene().active_shape().edge(i).v0==pointnum2:
      returnnum=i
      break

  return returnnum





def return_henlist(face):
  #面番号から面を構成する辺の番号を返す
  #前後にsetup_winged_edgeとclean_winged_edgeが必要

  tempvlist=xshade.scene().active_shape().face(face).vertex_indices

  henlist=[]
  for i in tempvlist:
    tempf=xshade.scene().active_shape().eccwfv(face,i,False)
    henlist.append(tempf)

  return henlist


def hantei_same_num(list1):
  #リスト内に同じ値が存在するなら1を返し、存在しないなら0を返す関数 例[1,1,3]→1 [1,3]→0
  list1.sort()
  nagasa=len(list1)
  returnnum=0
  if nagasa>1:
    kesu=[]
    for i in range(nagasa-1):
      if list1[i]==list1[i+1]:
        returnnum=1
  return returnnum


def return_menlist(edgenumber):
  #その辺を共有する面の面番号をリストで返す（引数　辺番号）
  menlist=[]
  edgevertex=[xshade.scene().active_shape().edge(edgenumber).v0,xshade.scene().active_shape().edge(edgenumber).v1]
  totalmenmen=xshade.scene().active_shape().number_of_faces
  for i in range(totalmenmen):
    konomen=0
    temppoint=list(xshade.scene().active_shape().face(i).vertex_indices)
    for j in temppoint:
      if edgevertex[0]==j:
        konomen+=1
      if edgevertex[1]==j:
        konomen+=1
    if konomen==2:
      menlist.append(i)

  return menlist

def return_pointlist(pointnum):
  #その点と接続されている頂点の頂点番号をリストで返す（引数　頂点番号）
  pointlist=[]
  totaledgesuu=xshade.scene().active_shape().number_of_edges
  for i in range(totaledgesuu):
    if xshade.scene().active_shape().edge(i).v0==pointnum:
      pointlist.append(xshade.scene().active_shape().edge(i).v1)
    if xshade.scene().active_shape().edge(i).v1==pointnum:
      pointlist.append(xshade.scene().active_shape().edge(i).v0)

  return pointlist

def substract_b_from_a(lista,listb):
  #リストＡからリストBに存在する要素を抜く  a[1,2,3,4,4,5]  b[3,4]  結果[1,2,5]
  #リストBに重複する値が存在するとエラーが出るので、あらかじめ重複する値は消しておく
  kesulis=[]
  for i in listb:
    for j in lista:
      if j==i:
        kesulis.append(i)
  for i in kesulis:
    lista.remove(i)
  return lista

dousasuru=0


def erase_same_num(list1):
  #リスト内に同じ値が重複する場合は一つに減らす関数 例[1,1,1,3,3,4]→[1,3,4]
  #呼び出す時はlist=erase_same_num(list)ではなく、erase_same_num(list)で良い
  list1.sort()
  nagasa=len(list1)
  if nagasa>1:
    kesu=[]
    for i in range(nagasa-1):
      if list1[i]==list1[i+1]:
        kesu.append(list1[i])
    kesukaisuu=len(kesu)
    if kesukaisuu>0:
      for i in kesu:
        list1.remove(i)






#動作条件確認

xscene=xshade.scene()
ashape=xshade.scene().active_shape()
ashapes=xshade.scene().active_shapes

if len(ashapes)==1 and ashape.type==7 and xscene.is_modify_mode==True:
  if xscene.selection_mode==1:
    aelist=[]
    for i in range(ashape.number_of_edges):
      if ashape.edge(i).active==True:
        aelist.append(i)
    if len(aelist)>0:dousasuru=1



if dousasuru>0:
  #上位パートに変換がかかっているなら動作しない

  if xshade.scene().active_shape().local_to_world_matrix!=((1.0, 0.0, 0.0, 0.0), (0.0, 1.0, 0.0, 0.0), (0.0, 0.0, 1.0, 0.0), (0.0, 0.0, 0.0, 1.0)):
    dousasuru=0
    dialog=xshade.create_dialog()
    dialog.append_push_button('上位パートに変換がかかっているため')
    dialog.append_push_button('スクリプトが実行できません')
    
    dialog.ask('エラー')

if dousasuru==1:
  if ashape.number_of_faces*len(aelist)>60000:
    dialogooi=xshade.create_dialog()
    dialogooi.append_push_button('「面数*選択辺」の値が')
    dialogooi.append_push_button('限界値を越えてますため')
    dialogooi.append_push_button('スクリプトは実行できません')
    dialogooi.ask('エラー')
    dousasuru=0




if dousasuru==1:
  #一括ベルト抜きをやるかきく
  dialogi=xshade.create_dialog()
  dialogi.append_push_button('一括ベルト抜きを')
  dialogi.append_push_button('実行しますか?')
  kekke=dialogi.ask('一括ベルト抜き')

  if kekke==False:dousasuru=0




if dousasuru==1:

  #元の形状をクリップボードにコピー
  ashape.copy()
  ashape.cleanup_redundant_vertices()
  ashape.adjust_face_direction()
  xscene.enter_modify_mode()

  #選択辺の両端の頂点位置をセットにしたリストを作る
  v01list=[]
  for i in aelist:
    v0=ashape.edge(i).v0
    v0pos=ashape.vertex(v0).position
    v1=ashape.edge(i).v1
    v1pos=ashape.vertex(v1).position
    v01list.append([v0pos,v1pos])


  #辺ごとに以下を繰り返す

  for i in v01list:
    v0pos=i[0]
    v1pos=i[1]
    va=-1
    vb=-1
    stedge=-1

    #ここで必要なデータを用意
    vvlist=[] #接続点リスト
    eflist=[] #辺の隣接面リスト

    for i in range(ashape.total_number_of_control_points):
      vvlist.append([])

    for i in range(ashape.number_of_edges):
      tv0=ashape.edge(i).v0
      tv1=ashape.edge(i).v1
      vvlist[tv0].append(tv1)
      vvlist[tv1].append(tv0)

#    print vvlist

#    ashape.setup_winged_edge()

#    for i in range(ashape.number_of_edges):
#      eflist.append(return_menlist(i))

    for i in range(ashape.number_of_edges):
      eflist.append([])

    ashape.setup_winged_edge()
    for i in range(ashape.number_of_faces):
      temphen=return_henlist(i)
      for gg in temphen:
        eflist[gg].append(i)

    for i in eflist:
      erase_same_num(i)

    ashape.clean_winged_edge()


#    ashape.clean_winged_edge()




    for vv in range(ashape.total_number_of_control_points):
      if ashape.vertex(vv).position==v0pos:va=vv
      if ashape.vertex(vv).position==v1pos:vb=vv
      if va!=-1 and vb!=-1:break

    if va!=-1 and vb!=-1:
      #辺の番号を探す
      stedge=return_edge_number(va,vb)

      if stedge!=-1:

        #ループ状に拡張
        pplist=[va,vb]
#        imaedge=stedge
        error=0
        alist=[]
        blist=[]
        if len(eflist[stedge])!=2:error=1


        for gg in pplist:
          stpoint=gg
          imapoint=gg
          imaedge=stedge

          #不具合が見つかったのでベルト抜きをやめる
          if error==1:
            break


          alist.append(gg)
          if len(vvlist[gg])>4:blist.append(gg)

          while(1):

            #今の点に接続してる点が3点以下の場合は拡張をやめる
            if len(vvlist[imapoint])<4:break

            #拡張途中で隣接面が一つしかない辺が見つかったらベルト抜きやめる
            tmen=eflist[imaedge]
            if len(tmen)!=2:
              error=1
              break

            svlist=[]
            for ff in tmen:
              tempvlist=ashape.face(ff).vertex_indices
              svlist=list(svlist)+list(tempvlist)

            #今の点の接続点からsvlistの点を引いたものが次の点
#            print svlist

            imavvlist=copy.copy(vvlist[imapoint])
            removelist=[]
            for ff in svlist:
              for ggg in imavvlist:
                if ff==ggg:
                  removelist.append(ff)
                  break

            erase_same_num(removelist)

#            print 'motovvlist',imavvlist
#            print 'svlist',svlist
            for ff in removelist:
              imavvlist.remove(ff) 

#            print 'atovvlist',imavvlist


            #残った点が二点以上の場合は拡張をやめる
            if len(imavvlist)>1:
#              print imavvlist
              break
            else:
              if imavvlist[0]==vb:
                alist.append(vb)
#                print 001
                break
              else:
                imaedge=return_edge_number(imavvlist[0],imapoint)
                imapoint=imavvlist[0]
                alist.append(imapoint)
                if len(vvlist[imapoint])>4:
                  blist.append(imapoint)
#                  print 002
                  break



        #結ぶリストを作成
        if error==0:

          #デバッグ用に拡張した頂点を選択状態に
#          xscene.selection_mode=2
#          for bb in alist:
#            ashape.vertex(bb).active=True

          #alistからblistをひいたclistを作成
          erase_same_num(alist)
          erase_same_num(blist)

#          print alist
#          print blist

          clist=[]
          for iii in alist:
            hantei=0
            for fff in blist:
              if iii==fff:hantei+=1
              if hantei>0:break
            if hantei==0:
              clist.append(iii)

#          print clist
          #結ぶリストを作成
          musubulist=[]
          for iii in clist:
            tempvlist=copy.copy(vvlist[iii])
#            print iii,tempvlist
            removelist2=[]

            for ggg in tempvlist:
              for ggg2 in alist:
                if ggg==ggg2:removelist2.append(ggg)

#            print tempvlist
#            print removelist2
            for ggg in removelist2:
              tempvlist.remove(ggg)

#            print tempvlist
            musubulist.append([tempvlist[0],tempvlist[1]])

          #頂点を削除すると同時に結ぶ
          ashape.begin_removing_control_points()
          for iii in clist:
            ashape.vertex(iii).remove()

          #結ぶ
          for iii in musubulist:
            ashape.append_edge(iii[0],iii[1])



          ashape.end_removing_control_points()
          ashape.adjust_face_direction()

  #やり直すか聞く

  dialog=xshade.create_dialog()
  idx3=dialog.append_push_button('処理を確定しますか?')
  kekka=dialog.ask('一括ベルト抜き')

  if kekka==True:renzoku=0

  if kekka==False:
    idou1=0
    if xshade.scene().active_shape().has_sis==True:
      idou1=1
    xshade.scene().paste()
    xshade.scene().select_sister(1)
    xshade.scene().clear()
    if idou1==1:
      xshade.scene().select_brother()
    xshade.scene().enter_modify_mode()
    ashape=xshade.scene().active_shape() 
    for i in aelist:
      ashape.edge(i).active=True


  #内包面の検出と処理
  if kekka==True:
    honsuu=4
    if honsuu==4 or honsuu==3:
      nailist=[]
      eflist=[]#辺に隣接されている面リストを辺番号順に格納したもの
      #return_henlist必要

      for i in range(xshade.scene().active_shape().number_of_edges):
        eflist.append([])

      xshade.scene().active_shape().setup_winged_edge()
      for i in range(xshade.scene().active_shape().number_of_faces):
        thenlist=return_henlist(i)
        for gg in thenlist:
          tempf=eflist[gg]
          tempf.append(i)
          eflist[gg]=tempf



      for i in range(xshade.scene().active_shape().number_of_faces):
        thenlist2=return_henlist(i)
        kazu=len(thenlist2)
        hantei=0
        for ggg in thenlist2:
          if len(eflist[ggg])>2:hantei+=1

        if hantei==kazu:
          nailist.append(i)

      xshade.scene().active_shape().clean_winged_edge()


      if len(nailist)>0:

        sagyou=0
        #ダイアログの表示
        dialog5=xshade.create_dialog()
        dialog5.append_push_button('内包面が生成されました')
        dialog5.append_push_button('処理を選択してください')
        idxxx1=dialog5.append_radio_button('/選択状態にする/削除する/何もしない')          
        dialog5.set_value(idxxx1,sagyou)

        kekka33=dialog5.ask('アラート')
        if kekka33==True:
          sagyou=dialog5.get_value(idxxx1)

          if sagyou==0:
            xshade.scene().selection_mode=0
            for i in range(xshade.scene().active_shape().number_of_faces):
              xshade.scene().active_shape().face(i).active=False
            for i in nailist:
              xshade.scene().active_shape().face(i).active=True

          if sagyou==1:
            xshade.scene().active_shape().begin_removing_faces()
            for i in nailist:
              xshade.scene().active_shape().face(i).remove()
            xshade.scene().active_shape().end_removing_faces()

            xshade.scene().active_shape().adjust_face_direction()
            xshade.scene().selection_mode=1

#            if kekka33==False:
#              kakka1=False
#              renzoku=1




